/*
 * *   Copyright (C) 2017 Mukul S. Bansal (mukul.bansal@uconn.edu).
 * *
 * *   This program is free software: you can redistribute it and/or modify
 * *   it under the terms of the GNU General Public License as published by
 * *   the Free Software Foundation, either version 3 of the License, or
 * *   (at your option) any later version.
 * *
 * *   This program is distributed in the hope that it will be useful,
 * *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 * *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * *   GNU General Public License for more details.
 * *
 * *   You should have received a copy of the GNU General Public License
 * *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * */




#define THRESHOLD 100

#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <ctype.h>
#include <string.h>
//#include <stdlib>
//#include <boost/lexical_cast.hpp>



using namespace std;


struct data     // for parsing data from files into array
{
	string genenode;
	bool isLeaf;
	bool isDummy;
	int event; // 0 = speciation, 1 = duplication, 2 = transfer, 3 = TL, 4 = TX
	string mapping;
	string recepient;
};
	

struct data2   // for storing event counts
{
	int spec;
	int dup;
	int tran;
	int TL;
	int TX;
	bool isLeaf;
	bool isDummy;
};


struct data3   // for storing all the mappings from a gene node
{
	string node;
	int count;
};


int main (int argc, char* argv[])
{
	char filename[100];
	char s[100];
	string line, part1, part2, part3, prevNode;
	string numsols;    // to store the line containing the total number of optimal solutions 
//	stringstream out;
//	string s;
		
//	int numfiles = boost::lexical_cast<int>(argv[2] );
 
	int numfiles = 1;
	int i;
	int FilesFullCount = 0;   // to check is all the input reconciliation files have run to completion (i.e., they didn't crash) 
	bool FilesFullFlag = false;


	vector< vector<data> > array;
	vector<data> arrayline;
	
	//set<string> nodenames;
	vector<string> nodenames;
	vector<string>::iterator it, newIt;
  
	//vector<data2> counts;
	//data2 tempcounts;
	map<string, data2> counts;
	data2 tempcounts;
	
	
	//vector< vector<data3> > mappings;
	//vector<data3> tempmappings;
	//data3 tempmap;
	map<string, vector<data3> > mappings;
	vector<data3> tempmappings;
	data3 tempmap;
	
	map<string, data3> frequentmapping;
	
	
	size_t found;
	size_t found2;
	size_t found3;
	size_t found_dummy;

	int index;
	
	int start = 0;
	// outer loop to iterate over the different input files
  	for(i = 1; ; i++)
	{
//		filename.clear();
		cout << i << endl;;
//		s = out.str();	
		arrayline.clear();
		
		sprintf(s,"%d",i);
//		itoa(i, s, 10);
		strcpy (filename,argv[1]);
		strcat(filename,s);		
		//filename = argv[1] + s; // prepare the file name		
	
		start = 0;    // to keep track of when we are in the reconcliation block
		
		ifstream myfile;
		myfile.open(filename);
		if (myfile.is_open ())
		{
			while (myfile.good ()) // inner lop to iterate over all lines in the file
			{
				
				data temp;
				getline (myfile, line);
				
				found3 = line.find("optimal");   // to copy the number of optimal solutions
				if (found3!=string::npos)
				{
					FilesFullCount++;
					numsols = line;
//					cout << numsols << endl;

				}
				
				
				found=line.find("Reconciliation:");
				if (found!=string::npos)
				{
					start = 1;
					continue;
				}
				
				if (start == 1)
				{
					found=line.find(":");
					found_dummy=line.find("Dummy");
					if(found == string::npos && found_dummy == string::npos)
						start = 0;
				}
				
				
				if (start == 1)
				{
//cout << line << endl;
					found=line.find(":");
					found_dummy=line.find("Dummy");
					if(found_dummy == string::npos)
					{
						if(found ==string::npos)
							cout << "ERROR!!" << endl;
					
						temp.isDummy = false;

						part1 = line.substr (0, found);
						temp.genenode = part1;

						if(i == 1)
						{
							nodenames.push_back(part1);
						}
						prevNode = part1;

						part2 = line.substr(found+1);
							
						found=part2.find("Leaf");
						if(found !=string::npos)
							temp.isLeaf = true;
						else temp.isLeaf = false;
						
						found=part2.find("Speciation");
						if(found !=string::npos)
						{
							temp.event = 0;
							found = part2.find("-->");
							part3 = part2.substr(found+4);
							temp.mapping = part3;
						}
							
						found=part2.find("Duplication");
						if(found !=string::npos)
						{
							temp.event = 1;
							found = part2.find("-->");
							part3 = part2.substr(found+4);
							temp.mapping = part3;
						}

						found=part2.find("Transfer");
						if(found !=string::npos)
						{
							temp.event = 2;
							found = part2.find("-->");
							found2 = part2.find(",", found+4);
							part3 = part2.substr(found+4, (found2 - (found + 4)));
							temp.mapping = part3;
							temp.recepient = part2.substr(found2 + 16);
							
						}	
					
					}
					else
					{
						//Handling dummy nodes
						temp.isDummy = true;
						temp.isLeaf = false;

						//Case for dummy nodes above leaf node
						if(true)
						{
							//dummy node name
							found = line.find(",");
							part1 = line.substr(0, found);
							temp.genenode = part1;

							//nodenames.insert(part1);
							if(i == 1)
							{
								nodenames.push_back(part1);
							}
							else if (!(std::find(nodenames.begin(), nodenames.end(), part1) != nodenames.end()))
							{
								it = find(nodenames.begin(), nodenames.end(), prevNode);
								newIt = nodenames.insert(it, part1);
								
							}
							part2 = line.substr(found+1);
							
							//get event info
							found=part2.find("TL");
							if(found !=string::npos)
							{
								temp.event = 3;
								found = part2.find("-->");
								found2 = part2.find(",", found+4);
								part3 = part2.substr(found+4, (found2 - (found + 4)));
								temp.mapping = part3;
								temp.recepient = part2.substr(found2 + 16);
								
							}

							found=part2.find("TX");
							if(found !=string::npos)
							{
								temp.event = 4;
								found = part2.find("-->");
								found_dummy = part2.find("Parent");
								found2 = part2.find(",", found_dummy);
								part3 = part2.substr(found+4, (found2 - (found + 4)));
								temp.mapping = part3;
								temp.recepient = part2.substr(found2 + 16);
								
							}
						}
					}			
						
					arrayline.push_back(temp);
					//cout << temp.isLeaf << " " << temp.genenode << " " << temp.event << " " << temp.mapping  << " " << temp.recepient << endl;
				}
				
				
			}
				
			myfile.close ();
			
			// fill the main array with the parsed data from all files
			array.push_back(arrayline);
		}
		 else
		 {
			 if (i ==1)
			 {	 
				 cout << "ERROR: Unable to open reconciliation files. Please ensure the files' filename-prefix and path are correct." << endl;
				 return 1;
			 }
			 
			 else
				 cout << "Processed " << i-1 << " files" << endl;
			 
			 if (FilesFullCount == (i-1))
			 {
				 FilesFullFlag = true;
			 }

			 break;
		 }
		 
		 
	}

	int y = array.size();

	for(int j = 0; j < y ; j++)
	{
		int x = array[j].size();

		for (int i = 0; i < x; i++)
		{
			//gene node not in counts yet
			if (counts.find(array[j][i].genenode) == counts.end())
			{
				tempcounts.spec = 0;
				tempcounts.tran = 0;
				tempcounts.dup = 0;
				tempcounts.TL = 0;
				tempcounts.TX = 0;
				tempcounts.isLeaf = false;
				tempcounts.isDummy = false;
				if (array[j][i].isDummy == true)
				{
					tempcounts.isDummy = true;
				}
				if (array[j][i].isLeaf == true)
				{
					tempcounts.isLeaf = true;
				}
				else
				{
					if (array[j][i].event == 0)
					{
						tempcounts.spec = tempcounts.spec + 1;
					}
					else if (array[j][i].event == 1)
					{
						tempcounts.dup = tempcounts.dup + 1;
					}
					else if (array[j][i].event == 2)
					{
						tempcounts.tran = tempcounts.tran + 1;
					}
					else if (array[j][i].event == 3)
					{
						tempcounts.TL = tempcounts.TL + 1;
					}
					else if (array[j][i].event == 4)
					{
						tempcounts.TX = tempcounts.TX + 1;
					}
				}
				counts.insert(make_pair(array[j][i].genenode, tempcounts));
			}
			//else increment the correct event
			else
			{
				if (array[j][i].isLeaf == false)
				{
					if (array[j][i].event == 0)
					{
						counts[array[j][i].genenode].spec ++;
					}
					else if (array[j][i].event == 1)
					{
						counts[array[j][i].genenode].dup ++;
					}
					else if (array[j][i].event == 2)
					{
						counts[array[j][i].genenode].tran ++;
					}
					else if (array[j][i].event == 3)
					{
						counts[array[j][i].genenode].TL ++;
					}
					else if (array[j][i].event == 4)
					{
						counts[array[j][i].genenode].TX ++;
					}
				}
				
			}
		}
	}
  
	
	// process to consolidate the mappings for any given gene node.

	for(int j = 0; j < y ; j++)
	{
		int x = array[j].size();
		for (int i = 0; i < x; i++)
		{
			tempmappings.clear();
			//gene node not in counts yet
			if (mappings.find(array[j][i].genenode) == mappings.end())
			{
				if (array[j][i].isLeaf == true)			
				{
					//vector<data3> tempmappings;
					//data3 tempmap;

					tempmap.node = " ";
					tempmap.count = -1;
					tempmappings.push_back(tempmap);

					mappings.insert(make_pair(array[j][i].genenode, tempmappings));
				}
				else
				{
					//vector<data3> tempmappings;
					//data3 tempmap;

					tempmap.node = array[j][i].mapping;
					tempmap.count = 1;
					tempmappings.push_back(tempmap);

					mappings.insert(make_pair(array[j][i].genenode, tempmappings));
				}
			}
			//else increment existing mapping, or add another
			else
			{
				//dont need to bother with leaf nodes
				if (array[j][i].isLeaf == false)
				{
					bool check = false;
					for (int n=0; n<mappings[array[j][i].genenode].size(); n++)
					{
						//mapping exists, just need to increment
						if (mappings[array[j][i].genenode][n].node == array[j][i].mapping)
						{
							mappings[array[j][i].genenode][n].count ++;
							check = true;
						}
					}
					//mapping doesnt exist yet
						if (check == false)
						{
							//data3 tempmap;
							tempmap.node = array[j][i].mapping;
							tempmap.count = 1;
							mappings[array[j][i].genenode].push_back(tempmap);
						}
				}
			
			}
		}
	}

	// process to choose the most frequent mapping for any given gene node

	for (it=nodenames.begin(); it!=nodenames.end(); it++)
	{
		//cout << *it << "|" << mappings[*it][0].node << endl;

		int best = 0;

		//handle leaf nodes
		if (mappings[*it][0].count == -1)
		{
			tempmap.node = " ";
			tempmap.count = -1;
			frequentmapping.insert(make_pair(*it, tempmap));

		}
		//handle all others
		else
		{
			for (int j=0; j<mappings[*it].size(); j++)
			{
				if (mappings[*it][j].count > best)
				{
					best = mappings[*it][j].count;
					tempmap.node = mappings[*it][j].node;
					tempmap.count = mappings[*it][j].count;
				}	
			}
			frequentmapping.insert(make_pair(*it, tempmap));
		}
	}


// calculate fraction of nodes with reliable events and mappings
	
	int totalnonleaf = 0;
	int goodevents = 0;
	int goodmappings = 0;
	int fullTL = 0;
	int fullTX = 0;
	
	for (it=nodenames.begin(); it!=nodenames.end(); it++)
	{
		if (counts[*it].isLeaf == false)
		{
			totalnonleaf++;

			if (counts[*it].isDummy == false)
			{
				if (((counts[*it].spec * 100)/y) >= THRESHOLD)
				{
					goodevents++;
				}
				else if (((counts[*it].dup * 100)/y) >= THRESHOLD)
				{
					goodevents++;
				}
				else if (((counts[*it].tran * 100)/y) >= THRESHOLD)
				{
					goodevents++;
				}
			
			
				if (((frequentmapping[*it].count * 100)/y) >= THRESHOLD)
				{
					goodmappings++;
				}

			}
			else
			{
				if (((counts[*it].TL * 100)/y) >= THRESHOLD)
				{
					fullTL++;
				}
				else if (((counts[*it].TX * 100)/y) >= THRESHOLD)
				{
					fullTX++;
				}
			}
			
		}
	}
			
	
	
	
// check if all files were full
if (FilesFullFlag == false)
		cout << "ERROR: Some reconciliation runs did not terminate correctly (" << FilesFullCount << " terminated correctly)" << endl;
	
	
	
	
	// output the aggregate information
	
	cout << endl << endl << "Aggregate reconciliation:" << endl;
	
//	cout << x <<  " " << y << endl;
	
	for (it=nodenames.begin(); it!=nodenames.end(); it++)
	{
		cout << *it << ": ";
		if (counts[*it].isLeaf == true)
		{
			cout << "Leaf Node" << endl;
		}
		else if (counts[*it].isDummy == false)
		{
			cout <<"[Speciations = " << counts[*it].spec << ", Duplications = " << counts[*it].dup << ", Transfers = " << counts[*it].tran << "]";
			cout << ", [Most Frequent mapping --> " << frequentmapping[*it].node << ", " << frequentmapping[*it].count << " times]." << endl;

		}
		else if (counts[*it].isDummy == true)
		{
			cout << "[TL events = " << counts[*it].TL << ", TX events = " << counts[*it].TX << "]";
			cout << ", [Most Frequent mapping --> " << frequentmapping[*it].node << ", " << frequentmapping[*it].count << " times]." << endl;
		}
	}

if (FilesFullFlag == true)
{	
	cout << endl << endl << "Percentage of non-dummy events with " << THRESHOLD << "% consistency = " << (((float)goodevents * 100)/(float)totalnonleaf) << endl;  
	cout << "Percentage of non-dummy mappings with " << THRESHOLD << "% consistency = " << (((float)goodmappings * 100)/(float)totalnonleaf) << endl;  
	cout << "Number off TL events with full presence: " << fullTL << endl;
	cout << "Number off TX events with full presence: " << fullTX << endl;
	cout << "Total number of non-leaf nodes in gene tree: " << totalnonleaf << endl;
	cout << numsols << endl;
}

else
{
	cout << endl << endl << "Percentage of events with " << THRESHOLD << "% consistency = ERROR" << endl;  
	cout << "Percentage of mappings with " << THRESHOLD << "% consistency = ERROR" << endl; 
	cout << "Number off TL events with full presence: " << fullTL << endl;
	cout << "Number off TX events with full presence: " << fullTX << endl;
	cout << "Total number of non-leaf nodes in gene tree: ERROR" << endl;
	cout << "Total number of optimal solutions: ERROR" << endl;
}

  return 0;
}



